## org.gnu.gtk
Class TextBuffer

    java.lang.Object
      org.gnu.glib.GObject
          org.gnu.gtk.TextBuffer

public class TextBuffer
extends GObject

The TextBuffer is the object used to store data to be displayed in a `TextView` widget. See the `TextView` widget description for details.

Field Summary

Fields inherited from class org.gnu.glib.GObject
`eventsInitialized`

Constructor Summary
`` `TextBuffer()` Creates a new buffer and a new default TextTagTable.
`protected` `TextBuffer(Handle handle)` Create butter from native handle
`` `TextBuffer(TextTagTable table)` Creates a new text buffer.

Method Summary
`void` `addClipboard(Clipboard clipboard)` Adds clipboard to the list of clipboards in which the selection contents of buffer are available.
`void` `addListener(TextBufferListener listener)` Register an object to receive text view event notification.
`void` `applyTag(java.lang.String name, TextIter start, TextIter end)` Looks up a tag by name and then applies it.
`void` `applyTag(TextTag tag, TextIter start, TextIter end)` Emits the "apply_tag" signal on buffer.
`boolean` `backspace(TextIter iter, boolean interactive, boolean default_editable)` Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter.
`void` `beginUserAction()` Called to indicate that the buffer operations between here and a call to `endUserAction()` are part of a single user-visible operation.
`void` `copyClipboard(Clipboard clip)` Copies the currently-selected text to a clipboard.
`protected static Handle` `create_tag(Handle buffer, java.lang.String name)`
`TextChildAnchor` `createChildAnchor(TextIter iter)` This is a convenience function which simply creates a child anchor with {link TextChildAnchor#TextChildAnchor()} and inserts it into the buffer
`TextMark` `createMark(java.lang.String markName, TextIter where, boolean leftGravity)` Creates a mark at position `where`.
`TextTag` `createTag(java.lang.String name)` Creates a TextTag initialised for use in this TextBuffer.
`void` `cutClipboard(Clipboard clipboard, boolean defaultEditable)` Copies the currently-selected text to a clipboard, then deletes said text if it's editable.
`void` `deleteMark(java.lang.String name)` Deletes the mark named `name`; the mark must exist.
`void` `deleteMark(TextMark mark)` Deletes `mark`, so that it's no longer located anywhere in the buffer.
`boolean` `deleteSelection(boolean interactive, boolean defaultEditable)` Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text.
`void` `deleteText(TextIter start, TextIter end)` Deletes text between `start` and `end`.
`boolean` `deleteTextInteractive(TextIter start, TextIter end, boolean defaultEditable)` Deletes all editable text in the given range.
`void` `endUserAction()` Should be paired with a call to `beginUserAction()`.
`protected static int` `findListener(java.util.Vector list, java.lang.Object listener)` Give us a way to locate a specific listener in a Vector.
`protected void` `fireTextBufferEvent(TextBufferEvent event)`
`int` `getCharCount()` Gets the number of characters in the buffer.
`TextIter` `getEndIter()` Returns Iterator for the end of the text
`java.lang.Class` `getEventListenerClass(java.lang.String signal)` TextView event handling.
`EventType` `getEventType(java.lang.String signal)`
`TextMark` `getInsert()` Returns the mark that represents the cursor (insertion point).
`TextIter` `getIter(int charOffset)` Obtains an iterator pointing to charOffset within the entire string, statring from the beginning
`TextIter` `getIter(int lineNumber, int charOffset)` Obtains an iterator pointing to charOffset within the given line.
`TextIter` `getIter(TextChildAnchor anchor)` Obtains the location of anchor within buffer.
`TextIter` `getIter(TextMark mark)` Returns an iter at the given mark
`int` `getLineCount()` Obtains the number of lines in the buffer.
`TextIter` `getLineIter(int line)` Obtains an iterator pointing to the start of the given line
`TextMark` `getMark(java.lang.String name)` Returns the mark named `name` in the buffer, or `null` if no such mark exists in the buffer
`boolean` `getModified()` Indicates whether the buffer has been modified since the last call to `setModified(boolean)` set the modification flag to FALSE.
`boolean` `getSelected()` Returns true if an area of the buffer is selected
`TextMark` `getSelectionBound()` Returns the mark that represents the selection bound.
`TextIter` `getSelectionEnd()` Returns an iterator for the end of the selection, or `null` if no text is selected.
`TextIter` `getSelectionStart()` Returns an iterator for the start of the selected text, or `null` if no text is selected.
`java.lang.String` `getSlice(TextIter start, TextIter end, boolean includeHiddenChars)` Returns the text in the range start,end.
`TextIter` `getStartIter()` Returns an iterator for the start of the text
`java.lang.String` `getText(TextIter start, TextIter end, boolean includeHiddenChars)` Returns the text in the range start,end.
`TextTagTable` `getTextTagTable()` Get the GtkTextTagTable associated with this buffer.
`static Type` `getType()` Retrieve the runtime type used by the GLib library.
`protected static void` `gtk_text_buffer_add_selection_clipboard(Handle buffer, Handle clipboard)`
`protected static void` `gtk_text_buffer_apply_tag_by_name(Handle buffer, java.lang.String name, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_apply_tag(Handle buffer, Handle tag, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_begin_user_action(Handle buffer)`
`protected static void` `gtk_text_buffer_copy_clipboard(Handle buffer, Handle clipboard)`
`protected static Handle` `gtk_text_buffer_create_child_anchor(Handle buffer, Handle iter)`
`protected static Handle` `gtk_text_buffer_create_mark(Handle buffer, java.lang.String markName, Handle where, boolean leftGravity)`
`protected static void` `gtk_text_buffer_cut_clipboard(Handle buffer, Handle clipboard, boolean defaultEditable)`
`protected static boolean` `gtk_text_buffer_delete_interactive(Handle buffer, Handle start, Handle end, boolean defaultEditable)`
`protected static void` `gtk_text_buffer_delete_mark_by_name(Handle buffer, java.lang.String name)`
`protected static void` `gtk_text_buffer_delete_mark(Handle buffer, Handle mark)`
`protected static boolean` `gtk_text_buffer_delete_selection(Handle buffer, boolean interactive, boolean defaultEditable)`
`protected static void` `gtk_text_buffer_delete(Handle buffer, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_end_user_action(Handle buffer)`
`protected static void` `gtk_text_buffer_get_bounds(Handle buffer, int start, int end)`
`protected static int` `gtk_text_buffer_get_char_count(Handle buffer)`
`protected static void` `gtk_text_buffer_get_end_iter(Handle buffer, Handle iter)`
`protected static Handle` `gtk_text_buffer_get_end_iterMOD(Handle buffer)`
`protected static Handle` `gtk_text_buffer_get_insert(Handle buffer)`
`protected static void` `gtk_text_buffer_get_iter_at_child_anchor(Handle buffer, Handle iter, int anchor)`
`protected static Handle` `gtk_text_buffer_get_iter_at_child_anchorMOD(Handle buffer, Handle anchor)`
`protected static void` `gtk_text_buffer_get_iter_at_line_index(Handle buffer, Handle iter, int lineNumber, int byteIndex)`
`protected static void` `gtk_text_buffer_get_iter_at_line_offset(Handle buffer, Handle iter, int lineNumber, int charOffset)`
`protected static Handle` `gtk_text_buffer_get_iter_at_line_offsetMOD(Handle buffer, int lineNumber, int charOffset)`
`protected static void` `gtk_text_buffer_get_iter_at_line(Handle buffer, Handle iter, int lineNumber)`
`protected static Handle` `gtk_text_buffer_get_iter_at_lineMOD(Handle buffer, int line)`
`protected static void` `gtk_text_buffer_get_iter_at_mark(Handle buffer, Handle iter, int mark)`
`protected static Handle` `gtk_text_buffer_get_iter_at_markMOD(Handle buffer, Handle mark)`
`protected static void` `gtk_text_buffer_get_iter_at_offset(Handle buffer, Handle iter, int charOffset)`
`protected static Handle` `gtk_text_buffer_get_iter_at_offsetMOD(Handle buffer, int charOffset)`
`protected static int` `gtk_text_buffer_get_line_count(Handle buffer)`
`protected static Handle` `gtk_text_buffer_get_mark(Handle buffer, java.lang.String name)`
`protected static boolean` `gtk_text_buffer_get_modified(Handle buffer)`
`protected static Handle` `gtk_text_buffer_get_selection_bound(Handle buffer)`
`protected static boolean` `gtk_text_buffer_get_selection_bounds(Handle buffer, int start, int end)`
`protected static Handle` `gtk_text_buffer_get_selection_end(Handle handle)`
`protected static boolean` `gtk_text_buffer_get_selection_exists(Handle handle)`
`protected static Handle` `gtk_text_buffer_get_selection_start(Handle handle)`
`protected static java.lang.String` `gtk_text_buffer_get_slice(Handle buffer, Handle start, Handle end, boolean includeHiddenChars)`
`protected static void` `gtk_text_buffer_get_start_iter(Handle buffer, Handle iter)`
`protected static Handle` `gtk_text_buffer_get_start_iterMOD(Handle buffer)`
`protected static Handle` `gtk_text_buffer_get_tag_table(Handle buffer)`
`protected static java.lang.String` `gtk_text_buffer_get_text(Handle buffer, Handle start, Handle end, boolean includeHiddenChars)`
`protected static int` `gtk_text_buffer_get_type()`
`protected static void` `gtk_text_buffer_insert_at_cursor(Handle buffer, java.lang.String text)`
`protected static void` `gtk_text_buffer_insert_child_anchor(Handle buffer, Handle iter, Handle anchor)`
`protected static boolean` `gtk_text_buffer_insert_interactive_at_cursor(Handle buffer, java.lang.String text, boolean defaultEditable)`
`protected static boolean` `gtk_text_buffer_insert_interactive(Handle buffer, Handle iter, java.lang.String text, boolean defaultEditable)`
`protected static void` `gtk_text_buffer_insert_pixbuf(Handle buffer, Handle iter, Handle pixbuf)`
`protected static boolean` `gtk_text_buffer_insert_range_interactive(Handle buffer, Handle iter, Handle start, Handle end, boolean defaultEditable)`
`protected static void` `gtk_text_buffer_insert_range(Handle buffer, Handle iter, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_insert(Handle buffer, Handle iter, java.lang.String text)`
`protected static void` `gtk_text_buffer_move_mark_by_name(Handle buffer, java.lang.String name, Handle where)`
`protected static void` `gtk_text_buffer_move_mark(Handle buffer, Handle mark, Handle where)`
`protected static Handle` `gtk_text_buffer_new_noTable()`
`protected static Handle` `gtk_text_buffer_new(Handle table)`
`protected static void` `gtk_text_buffer_paste_clipboard(Handle buffer, Handle clipboard, Handle overrideLocation, boolean defaultEditable)`
`protected static void` `gtk_text_buffer_paste_clipboardInsertPosition(Handle handle, Handle clip, boolean editable)`
`protected static void` `gtk_text_buffer_place_cursor(Handle buffer, Handle where)`
`protected static void` `gtk_text_buffer_remove_all_tags(Handle buffer, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_remove_selection_clipboard(Handle buffer, Handle clipboard)`
`protected static void` `gtk_text_buffer_remove_tag_by_name(Handle buffer, java.lang.String name, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_remove_tag(Handle buffer, Handle tag, Handle start, Handle end)`
`protected static void` `gtk_text_buffer_select_range(Handle handle, Handle ins, Handle bound)`
`protected static void` `gtk_text_buffer_set_modified(Handle buffer, boolean setting)`
`protected static void` `gtk_text_buffer_set_text(Handle buffer, java.lang.String text)`
`void` `inserChildAnchor(TextIter iter, TextChildAnchor anchor)` Inserts a child widget anchor into the text buffer at iter.
`protected static void` `insert_with_tag(Handle buffer, Handle iter, java.lang.String text, java.lang.String tag)`
`void` `insertPixbuf(TextIter iter, Pixbuf pixbuf)` Inserts an image into the text buffer at iter.
`void` `insertRange(TextIter iter, TextIter start, TextIter end)` Copies text, tags, and pixbufs between start and end (the order of start and end doesn't matter) and inserts the copy at iter.
`boolean` `insertRangeInteractive(TextIter iter, TextIter start, TextIter end, boolean defaultEditable)` Same as `insertRange(TextIter, TextIter, TextIter)`, but does nothing if the insertion point isn't editable.
`void` `insertText(java.lang.String text)` Inserts text at the current cursor position
`void` `insertText(TextIter iter, java.lang.String text)` Inserts text at position iter.
`void` `insertText(TextIter iter, java.lang.String text, java.lang.String tag)` Inserts text and applies a tag to that text.
`void` `insertText(TextIter iter, java.lang.String text, java.lang.String[] tags)` Inserts text and applies tags to that text.
`boolean` `insertTextInteractive(java.lang.String text, boolean defaultEditable)` Calls `insertTextInteractive(TextIter, String, boolean)` at the cursor position.
`boolean` `insertTextInteractive(TextIter iter, java.lang.String text, boolean defaultEditable)` Like `insertText(TextIter, String)`, but the insertion will not occur if iter is at a non-editable location in the buffer.
`boolean` `markExists(java.lang.String name)` Returns true if a mark exists with the given name.
`void` `moveMark(java.lang.String name, TextIter where)` Moves the mark named `name` (which must exist) to location `where`
`void` `moveMark(TextMark mark, TextIter where)` Moves `mark` to the new location `where`.
`void` `pasteClipboard(Clipboard clipboard, boolean defaultEditable)` Pastes the contents of a clipboard at the insertion point.
`void` `pasteClipboard(Clipboard clipboard, TextIter location, boolean defaultEditable)` Pastes the contents of a clipboard at location.
`void` `placeCursor(TextIter where)` This function moves the "insert" and "selection_bound" marks simultaneously.
`void` `removeAllTags(TextTag start, TextTag end)` Removes all tags in the range between start and end.
`void` `removeClipboard(Clipboard clipboard)` Removes a clipboard added with `addClipboard(Clipboard)`
`void` `removeListener(TextBufferListener listener)` Unregister an object that was receiving text view event notification.
`void` `removeTag(java.lang.String name, TextIter start, TextIter end)` Removes a tag based on it's name.
`void` `removeTag(TextTag tag, TextIter start, TextIter end)` Emits the "remove_tag" signal.
`void` `selectRange(TextIter ins, TextIter bound)` This function moves the "insert" and "selection_bound" marks simultaneously.
`void` `setModified(boolean setting)` Used to keep track of whether the buffer has been modified since the last time it was saved.
`void` `setText(java.lang.String text)` Deletes current contents of buffer, and inserts `text` instead.

Methods inherited from class org.gnu.glib.GObject

`addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addListener, equals, freezeNotify, getBooleanProperty, getData, getData, getDoubleProperty, getFloatProperty, getGObjectFromHandle, getHandle, getIntFromHandle, getIntProperty, getJavaObjectProperty, getLongProperty, getNullHandle, getPixbufProperty, getProperty, getStringFromHandle, getStringProperty, hashCode, hasProperty, instantiateJGObjectFromGType, notify, removeEventHandler, removeListener, retrieveGObject, setBooleanProperty, setData, setData, setDoubleProperty, setFloatProperty, setHandle, setIntProperty, setJavaObjectProperty, setLongProperty, setPixbufProperty, setProperty, setStringProperty, thawNotify`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TextBuffer

    protected TextBuffer(Handle handle)

  Create butter from native handle

### TextBuffer

    public TextBuffer(TextTagTable table)

  Creates a new text buffer.

Parameters:
  `table` - A tag table

### TextBuffer

    public TextBuffer()

  Creates a new buffer and a new default TextTagTable.

Method Detail

### getLineCount

    public int getLineCount()

  Obtains the number of lines in the buffer. This value is cached, so the function is very fast.

  Returns:
    The number of lines in the bufer.

### getCharCount

    public int getCharCount()

  Gets the number of characters in the buffer. Note that characters and bytes are not the same. You can't expect the contents of the buffer in string form to be this many bytes long. The character count is cached, so this function is very fast.

  Returns:
    Number of characters in the buffer.

### getTextTagTable

    public TextTagTable getTextTagTable()

  Get the GtkTextTagTable associated with this buffer.

  Returns:
    Associated TextTagTable.

### insertText

    public void insertText(TextIter iter,
                           java.lang.String text)

  Inserts text at position iter. Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal. iter is invalidated when insertion occurs (because the buffer contents change), but the default signal handler revalidates it to point to the end of the inserted text.

  Parameters:
    `iter` - A position in the buffer
    `text` - The text to insert

### insertText

    public void insertText(java.lang.String text)

  Inserts text at the current cursor position

  Parameters:
    `text` - The text to insert

### insertTextInteractive

    public boolean insertTextInteractive(TextIter iter,
                                         java.lang.String text,
                                         boolean defaultEditable)

  Like `insertText(TextIter, String)`, but the insertion will not occur if iter is at a non-editable location in the buffer. Usually you want to prevent insertions at ineditable locations if the insertion results from a user action (is interactive).

  defaultEditable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of `TextView.getEditable()` is appropriate here.

  Parameters:
    `iter` - A position in buffer
    `text` - The text to insert
    `defaultEditable` - Default editability of buffer
  Returns:
    Whether text was actually inserted

### insertTextInteractive

    public boolean insertTextInteractive(java.lang.String text,
                                         boolean defaultEditable)

  Calls `insertTextInteractive(TextIter, String, boolean)` at the cursor position.

  defaultEditable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of `TextView.getEditable()` is appropriate here.

  Parameters:
    `text` - The text to insert.
    `defaultEditable` - Default editability of buffer
  Returns:
    Whether text was actually inserted.

### insertRange

    public void insertRange(TextIter iter,
                            TextIter start,
                            TextIter end)

  Copies text, tags, and pixbufs between start and end (the order of start and end doesn't matter) and inserts the copy at iter. Used instead of simply getting/inserting text because it preserves images and tags. If start and end are in a different buffer from buffer, the two buffers must share the same tag table.

  Implemented via emissions of the insert_text and apply_tag signals, so expect those.

  Parameters:
    `iter` - A position in the buffer
    `start` - A position in a TextBuffer
    `end` - Another position in the same buffer as start

### insertText

    public void insertText(TextIter iter,
                           java.lang.String text,
                           java.lang.String tag)

  Inserts text and applies a tag to that text.

  Parameters:
    `iter` - Place to insert text
    `text` - Text to insert
    `tag` - name of TextTag to apply to that text.

### insertText

    public void insertText(TextIter iter,
                           java.lang.String text,
                           java.lang.String[] tags)

  Inserts text and applies tags to that text.

  Parameters:
    `iter` - Place to insert text
    `text` - Text to insert
    `tags` - Array of TextTag names to apply to that text.

### insertRangeInteractive

    public boolean insertRangeInteractive(TextIter iter,
                                          TextIter start,
                                          TextIter end,
                                          boolean defaultEditable)

  Same as `insertRange(TextIter, TextIter, TextIter)`, but does nothing if the insertion point isn't editable. The defaultEditable parameter indicates whether the text is editable at iter if no tags enclosing iter affect editability. Typically the result of `TextView.getEditable()` is appropriate here.

  Parameters:
    `iter` - A position in buffer
    `start` - A position in a TextBuffer
    `end` - Another position in the same buffer as start
    `defaultEditable` - default editability of the buffer
  Returns:
    Whether an insertion was possible at iter.

### deleteText

    public void deleteText(TextIter start,
                           TextIter end)

  Deletes text between `start` and `end`. The order of start and end is not actually relevant. This function actually emits the "delete_range" signal, and the default handler of that signal deletes the text. Because the buffer is modified, all outstanding iterators become invalid after calling this function; however, the start and end will be re-initialized to point to the location where text was deleted.

  Parameters:
    `start` - A position in buffer
    `end` - Another position in buffer.

### deleteTextInteractive

    public boolean deleteTextInteractive(TextIter start,
                                         TextIter end,
                                         boolean defaultEditable)

  Deletes all editable text in the given range. Calls `deleteText(TextIter, TextIter)` for each editable sub-range of start,end. `start` and `end` are revalidated to point to the location of the last deleted range, or left untouched if no text was deleted.

  Parameters:
    `start` - Start of range to delete
    `end` - End of range
    `defaultEditable` - Ehether the buffer is editable by default
  Returns:
    Whether some text was actually deleted

### setText

    public void setText(java.lang.String text)

  Deletes current contents of buffer, and inserts `text` instead.

  Parameters:
    `text` - The text to use as the content of the buffer.

### getText

    public java.lang.String getText(TextIter start,
                                    TextIter end,
                                    boolean includeHiddenChars)

  Returns the text in the range start,end. Excludes undisplayed text (text marked with tags that set the invisibility attribute) if includeHiddenChars is FALSE. Does not include characters representing embedded images, so byte and character indexes into the returned string do not correspond to byte and character indexes into the buffer. Contrast with `getSlice(TextIter, TextIter, boolean)`.

  Parameters:
    `start` - Start of a range
    `end` - End of a range
    `includeHiddenChars` - Whether to include invisible text
  Returns:
    The text of the buffer

### getSlice

    public java.lang.String getSlice(TextIter start,
                                     TextIter end,
                                     boolean includeHiddenChars)

  Returns the text in the range start,end. Excludes undisplayed text (text marked with tags that set the invisibility attribute) if includeHiddenChars is FALSE. The returned string includes a 0xFFFC character whenever the buffer contains embedded images, so byte and character indexes into the returned string do correspond to byte and character indexes into the buffer. Contrast with `getText(TextIter, TextIter, boolean)`. Note that 0xFFFC can occur in normal text as well, so it is not a reliable indicator that a pixbuf or widget is in the buffer.

  Parameters:
    `start` - Start of a range
    `end` - End of a range.
    `includeHiddenChars` - Whether to include invisible text
  Returns:
    The string

### insertPixbuf

    public void insertPixbuf(TextIter iter,
                             Pixbuf pixbuf)

  Inserts an image into the text buffer at iter. The image will be counted as one character in character counts, and when obtaining the buffer contents as a string, will be represented by the Unicode "object replacement character" 0xFFFC. Note that the "slice" variants for obtaining portions of the buffer as a string include this character for pixbufs, but the "text" variants do not.

  Parameters:
    `iter` - Location to insert the pixbuf
    `pixbuf` - A Pixbuf

### inserChildAnchor

    public void inserChildAnchor(TextIter iter,
                                 TextChildAnchor anchor)

  Inserts a child widget anchor into the text buffer at iter. The anchor will be counted as one character in character counts, and when obtaining the buffer contents as a string, will be represented by the Unicode "object replacement character" 0xFFFC. Note that the "slice" variants for obtaining portions of the buffer as a string include this character for child anchors, but the "text" variants do not.

  Parameters:
    `iter` - Location to insert the anchor
    `anchor` - A TextChildAnchor

### createChildAnchor

    public TextChildAnchor createChildAnchor(TextIter iter)

  This is a convenience function which simply creates a child anchor with {link TextChildAnchor#TextChildAnchor()} and inserts it into the buffer

  Parameters:
    `iter` - Location in the buffer
  Returns:
    The created child anchor

### createMark

    public TextMark createMark(java.lang.String markName,
                               TextIter where,
                               boolean leftGravity)

  Creates a mark at position `where`. Otherwise, the mark can be retrieved by name using `getMark(String)`. If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (leftGravity = FALSE), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

  Emits the "mark_set" event as notification of the mark's initial placement.

  Parameters:
    `markName` - Name for mark
    `where` - Location to place mark
    `leftGravity` - Whether the mark has left gravity
  Returns:
    The new TextMark object

### moveMark

    public void moveMark(TextMark mark,
                         TextIter where)

  Moves `mark` to the new location `where`. Emits the "mark_set" event as notification of the move.

  Parameters:
    `mark` - A TextMark
    `where` - New location for mark in buffer

### moveMark

    public void moveMark(java.lang.String name,
                         TextIter where)

  Moves the mark named `name` (which must exist) to location `where`

  Parameters:
    `name` - Name of a mark
    `where` - New location for mark

### deleteMark

    public void deleteMark(TextMark mark)

  Deletes `mark`, so that it's no longer located anywhere in the buffer. There is no way to undelete a mark. `TextMark.getDeleted()` indicates that a mark no longer belongs to a buffer. The "mark_deleted" signal will be emitted as notification after the mark is deleted.

  Parameters:
    `mark` - A TextMark in buffer

### deleteMark

    public void deleteMark(java.lang.String name)

  Deletes the mark named `name`; the mark must exist.

  Parameters:
    `name` - The name of the mark to delete
  See Also:
    `deleteMark(TextMark)`

### markExists

    public boolean markExists(java.lang.String name)

  Returns true if a mark exists with the given name.

### getMark

    public TextMark getMark(java.lang.String name)

  Returns the mark named `name` in the buffer, or `null` if no such mark exists in the buffer

### getInsert

    public TextMark getInsert()

  Returns the mark that represents the cursor (insertion point). Equivalent to calling gtk_text_buffer_get_mark() to get the mark named "insert", but very slightly more efficient, and involves less typing.

  Returns:
    Insertion point mark

### getSelectionBound

    public TextMark getSelectionBound()

  Returns the mark that represents the selection bound. Equivalent to calling `getMark(String)` to get the mark named "selection_bound", but very slightly more efficient, and involves less typing.

  The currently-selected text in buffer is the region between the "selection_bound" and "insert" marks. If "selection_bound" and "insert" are in the same place, then there is no current selection.

  Returns:
    Mark for the selection

### placeCursor

    public void placeCursor(TextIter where)

  This function moves the "insert" and "selection_bound" marks simultaneously. If you move them to the same place in two steps with `moveMark(TextMark, TextIter)`, you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

  Parameters:
    `where` - Where to put the cursor

### applyTag

    public void applyTag(TextTag tag,
                         TextIter start,
                         TextIter end)

  Emits the "apply_tag" signal on buffer. The default handler for the signal applies tag to the given range. start and end do not have to be in order.

  Parameters:
    `tag` - A TextTag
    `start` - One bound of range to be tagged
    `end` - Other bound of range to be tagged

### removeTag

    public void removeTag(TextTag tag,
                          TextIter start,
                          TextIter end)

  Emits the "remove_tag" signal. The default handler for the signal removes all occurrences of tag from the given range. start and end don't have to be in order

  Parameters:
    `tag` - A TextTag
    `start` - One bound of range to be untagged
    `end` - Other bound of range to be untagged

### applyTag

    public void applyTag(java.lang.String name,
                         TextIter start,
                         TextIter end)

  Looks up a tag by name and then applies it.

  Parameters:
    `name` - Name of a named TextTag
    `start` - One bound of range to be tagged
    `end` - Other bound of range to be tagged

### removeTag

    public void removeTag(java.lang.String name,
                          TextIter start,
                          TextIter end)

  Removes a tag based on it's name.

  Parameters:
    `name` - Name of a TextTag
    `start` - One bound of range to be untagged
    `end` - Other bound of range to be untagged

### removeAllTags

    public void removeAllTags(TextTag start,
                              TextTag end)

  Removes all tags in the range between start and end. Be careful with this function; it could remove tags added in code unrelated to the code you're currently writing. That is, using this function is probably a bad idea if you have two or more unrelated code sections that add tags.

  Parameters:
    `start` - One bound of range to be untagged
    `end` - Other bound of range to be untagged

### getIter

    public TextIter getIter(int lineNumber,
                            int charOffset)

  Obtains an iterator pointing to charOffset within the given line. The charOffset must exist, offsets off the end of the line are not allowed. Note characters, not bytes; UTF-8 may encode one character as multiple bytes.

  Parameters:
    `lineNumber` - Line number counting from 0
    `charOffset` - Char offset from start of line
  Returns:
    Iterator

### getIter

    public TextIter getIter(int charOffset)

  Obtains an iterator pointing to charOffset within the entire string, statring from the beginning

  Parameters:
    `charOffset` - Character offset from the beginning of the text
  Returns:
    Iterator pointing to that point.

### getLineIter

    public TextIter getLineIter(int line)

  Obtains an iterator pointing to the start of the given line

  Parameters:
    `line` - The line
  Returns:
    Iterator

### getIter

    public TextIter getIter(TextMark mark)

  Returns an iter at the given mark

  Parameters:
    `mark` - The position for the iter
  Returns:
    Iterator

### getIter

    public TextIter getIter(TextChildAnchor anchor)

  Obtains the location of anchor within buffer.

  Parameters:
    `anchor` - An anchor that appears in the buffer.
  Returns:
    Iterator

### getStartIter

    public TextIter getStartIter()

  Returns an iterator for the start of the text

  Returns:
    iterator

### getEndIter

    public TextIter getEndIter()

  Returns Iterator for the end of the text

  Returns:
    Iterator for the end of the text.

### getModified

    public boolean getModified()

  Indicates whether the buffer has been modified since the last call to `setModified(boolean)` set the modification flag to FALSE. Used for example to enable a "save" function in a text editor.

  Returns:
    TRUE if the buffer has been modified

### setModified

    public void setModified(boolean setting)

  Used to keep track of whether the buffer has been modified since the last time it was saved. Whenever the buffer is saved to disk, call setModified(FALSE). When the buffer is modified, it will automatically toggled on the modified bit again. When the modified bit flips, the buffer emits a "modified_changed" event.

  Parameters:
    `setting` - Modification flag setting

### deleteSelection

    public boolean deleteSelection(boolean interactive,
                                   boolean defaultEditable)

  Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text. If interactive is TRUE, the editability of the selection will be considered (users can't delete uneditable text).

  Parameters:
    `interactive` - Whether the deletion is caused by user interaction
    `defaultEditable` - Whether the buffer is editable by default
  Returns:
    Whether there was a non-empty selection to delete

### pasteClipboard

    public void pasteClipboard(Clipboard clipboard,
                               TextIter location,
                               boolean defaultEditable)

  Pastes the contents of a clipboard at location. (Note: pasting is asynchronous, that is, we'll ask for the paste data and return, and at some point later after the main loop runs, the paste data will be inserted.)

  Parameters:
    `clipboard` - The Clipboard to paste from
    `location` - Location to insert pasted text
    `defaultEditable` - Whether the buffer is editable by default

### pasteClipboard

    public void pasteClipboard(Clipboard clipboard,
                               boolean defaultEditable)

  Pastes the contents of a clipboard at the insertion point. (Note: pasting is asynchronous, that is, we'll ask for the paste data and return, and at some point later after the main loop runs, the paste data will be inserted.)

  Parameters:
    `clipboard` - The Clipboard to paste from
    `defaultEditable` - Whether the buffer is editable by default

### copyClipboard

    public void copyClipboard(Clipboard clip)

  Copies the currently-selected text to a clipboard.

  Parameters:
    `clip` - The clipboard to copy the text to

### cutClipboard

    public void cutClipboard(Clipboard clipboard,
                             boolean defaultEditable)

  Copies the currently-selected text to a clipboard, then deletes said text if it's editable.

  Parameters:
    `clipboard` - The Clipboard object to cut to.
    `defaultEditable` - Default editability of the buffer

### getSelected

    public boolean getSelected()

  Returns true if an area of the buffer is selected

  Returns:
    True if an area is selected

### getSelectionStart

    public TextIter getSelectionStart()

  Returns an iterator for the start of the selected text, or `null` if no text is selected.

### getSelectionEnd

    public TextIter getSelectionEnd()

  Returns an iterator for the end of the selection, or `null` if no text is selected.

### beginUserAction

    public void beginUserAction()

  Called to indicate that the buffer operations between here and a call to `endUserAction()` are part of a single user-visible operation. The operations between beginUserAction() and endUserAction() can then be grouped when creating an undo stack. TextBuffer maintains a count of calls to beginUserAction() that have not been closed with a call to endUserAction(), and emits the "begin_user_action" and "end_user_action" event only for the outermost pair of calls. This allows you to build user actions from other user actions.

  The "interactive" buffer mutation functions automatically call begin/end user action around the buffer operations they perform, so there's no need to add extra calls if you user action consists solely of a single call to one of those functions.

### endUserAction

    public void endUserAction()

  Should be paired with a call to `beginUserAction()`. See that function for a full explanation.

### addClipboard

    public void addClipboard(Clipboard clipboard)

  Adds clipboard to the list of clipboards in which the selection contents of buffer are available. In most cases, clipboard will be the GtkClipboard of type GDK_SELECTION_PRIMARY for a view of buffer.

  Parameters:
    `clipboard` - A ClipBoard

### removeClipboard

    public void removeClipboard(Clipboard clipboard)

  Removes a clipboard added with `addClipboard(Clipboard)`

  Parameters:
    `clipboard` - The clipboard to remove

### selectRange

    public void selectRange(TextIter ins,
                            TextIter bound)

  This function moves the "insert" and "selection_bound" marks simultaneously. If you move them in two steps with moveMark, you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

  Parameters:
    `ins` - where to put the "insert" mark
    `bound` - where to put the "selection_bound" mark
  Since:
    2.4

### backspace

    public boolean backspace(TextIter iter,
                             boolean interactive,
                             boolean default_editable)

  Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter. In the normal case a single character will be deleted, but when combining accents are involved, more than one character can be deleted, and when precomposed character and accent combinations are involved, less than one character will be deleted. Because the buffer is modified, all outstanding iterators become invalid after calling this function; however, the iter will be re-initialized to point to the location where text was deleted.

  Parameters:
    `iter` - A position in the buffer.
    `interactive` - Whether the deletion is caused by user interaction.
    `default_editable` - Whether the buffer is editable by default.
  Returns:
    TRUE if the buffer was modified.

### getEventListenerClass

    public java.lang.Class getEventListenerClass(java.lang.String signal)

  TextView event handling.

  Overrides:
    `getEventListenerClass` in class `GObject`

### getEventType

    public EventType getEventType(java.lang.String signal)

  Overrides:
    `getEventType` in class `GObject`

### addListener

    public void addListener(TextBufferListener listener)

  Register an object to receive text view event notification.

  Parameters:
    `listener` - The object that has implemented the TextBufferListener interface that is to receive the text view events.

### removeListener

    public void removeListener(TextBufferListener listener)

  Unregister an object that was receiving text view event notification.

  Parameters:
    `listener` - The object that is to no longer receive text view events.

### fireTextBufferEvent

    protected void fireTextBufferEvent(TextBufferEvent event)

### findListener

    protected static int findListener(java.util.Vector list,
                                      java.lang.Object listener)

  Give us a way to locate a specific listener in a Vector.

  Parameters:
    `list` - The Vector of listeners to search.
    `listener` - The object that is to be located in the Vector.
  Returns:
    Returns the index of the listener in the Vector, or -1 if the listener is not contained in the Vector.

### getType

    public static Type getType()

  Retrieve the runtime type used by the GLib library.

### createTag

    public TextTag createTag(java.lang.String name)

  Creates a TextTag initialised for use in this TextBuffer. If a TextTag already exists with this name null is returned.

### gtk_text_buffer_get_type

    protected static final int gtk_text_buffer_get_type()

### gtk_text_buffer_new

    protected static final Handle gtk_text_buffer_new(Handle table)

### gtk_text_buffer_get_line_count

    protected static final int gtk_text_buffer_get_line_count(Handle buffer)

### gtk_text_buffer_get_char_count

    protected static final int gtk_text_buffer_get_char_count(Handle buffer)

### gtk_text_buffer_get_tag_table

    protected static final Handle gtk_text_buffer_get_tag_table(Handle buffer)

### gtk_text_buffer_set_text

    protected static final void gtk_text_buffer_set_text(Handle buffer,
                                                         java.lang.String text)

### gtk_text_buffer_insert

    protected static final void gtk_text_buffer_insert(Handle buffer,
                                                       Handle iter,
                                                       java.lang.String text)

### gtk_text_buffer_insert_at_cursor

    protected static final void gtk_text_buffer_insert_at_cursor(Handle buffer,
                                                                 java.lang.String text)

### gtk_text_buffer_insert_interactive

    protected static final boolean gtk_text_buffer_insert_interactive(Handle buffer,
                                                                      Handle iter,
                                                                      java.lang.String text,
                                                                      boolean defaultEditable)

### gtk_text_buffer_insert_interactive_at_cursor

    protected static final boolean gtk_text_buffer_insert_interactive_at_cursor(Handle buffer,
                                                                                java.lang.String text,
                                                                                boolean defaultEditable)

### gtk_text_buffer_insert_range

    protected static final void gtk_text_buffer_insert_range(Handle buffer,
                                                             Handle iter,
                                                             Handle start,
                                                             Handle end)

### gtk_text_buffer_insert_range_interactive

    protected static final boolean gtk_text_buffer_insert_range_interactive(Handle buffer,
                                                                            Handle iter,
                                                                            Handle start,
                                                                            Handle end,
                                                                            boolean defaultEditable)

### gtk_text_buffer_delete

    protected static final void gtk_text_buffer_delete(Handle buffer,
                                                       Handle start,
                                                       Handle end)

### gtk_text_buffer_delete_interactive

    protected static final boolean gtk_text_buffer_delete_interactive(Handle buffer,
                                                                      Handle start,
                                                                      Handle end,
                                                                      boolean defaultEditable)

### gtk_text_buffer_get_text

    protected static final java.lang.String gtk_text_buffer_get_text(Handle buffer,
                                                                     Handle start,
                                                                     Handle end,
                                                                     boolean includeHiddenChars)

### gtk_text_buffer_get_slice

    protected static final java.lang.String gtk_text_buffer_get_slice(Handle buffer,
                                                                      Handle start,
                                                                      Handle end,
                                                                      boolean includeHiddenChars)

### gtk_text_buffer_insert_pixbuf

    protected static final void gtk_text_buffer_insert_pixbuf(Handle buffer,
                                                              Handle iter,
                                                              Handle pixbuf)

### gtk_text_buffer_insert_child_anchor

    protected static final void gtk_text_buffer_insert_child_anchor(Handle buffer,
                                                                    Handle iter,
                                                                    Handle anchor)

### gtk_text_buffer_create_child_anchor

    protected static final Handle gtk_text_buffer_create_child_anchor(Handle buffer,
                                                                      Handle iter)

### gtk_text_buffer_create_mark

    protected static final Handle gtk_text_buffer_create_mark(Handle buffer,
                                                              java.lang.String markName,
                                                              Handle where,
                                                              boolean leftGravity)

### gtk_text_buffer_move_mark

    protected static final void gtk_text_buffer_move_mark(Handle buffer,
                                                          Handle mark,
                                                          Handle where)

### gtk_text_buffer_delete_mark

    protected static final void gtk_text_buffer_delete_mark(Handle buffer,
                                                            Handle mark)

### gtk_text_buffer_get_mark

    protected static final Handle gtk_text_buffer_get_mark(Handle buffer,
                                                           java.lang.String name)

### gtk_text_buffer_move_mark_by_name

    protected static final void gtk_text_buffer_move_mark_by_name(Handle buffer,
                                                                  java.lang.String name,
                                                                  Handle where)

### gtk_text_buffer_delete_mark_by_name

    protected static final void gtk_text_buffer_delete_mark_by_name(Handle buffer,
                                                                    java.lang.String name)

### gtk_text_buffer_get_insert

    protected static final Handle gtk_text_buffer_get_insert(Handle buffer)

### gtk_text_buffer_get_selection_bound

    protected static final Handle gtk_text_buffer_get_selection_bound(Handle buffer)

### gtk_text_buffer_place_cursor

    protected static final void gtk_text_buffer_place_cursor(Handle buffer,
                                                             Handle where)

### gtk_text_buffer_apply_tag

    protected static final void gtk_text_buffer_apply_tag(Handle buffer,
                                                          Handle tag,
                                                          Handle start,
                                                          Handle end)

### gtk_text_buffer_remove_tag

    protected static final void gtk_text_buffer_remove_tag(Handle buffer,
                                                           Handle tag,
                                                           Handle start,
                                                           Handle end)

### gtk_text_buffer_apply_tag_by_name

    protected static final void gtk_text_buffer_apply_tag_by_name(Handle buffer,
                                                                  java.lang.String name,
                                                                  Handle start,
                                                                  Handle end)

### gtk_text_buffer_remove_tag_by_name

    protected static final void gtk_text_buffer_remove_tag_by_name(Handle buffer,
                                                                   java.lang.String name,
                                                                   Handle start,
                                                                   Handle end)

### gtk_text_buffer_remove_all_tags

    protected static final void gtk_text_buffer_remove_all_tags(Handle buffer,
                                                                Handle start,
                                                                Handle end)

### gtk_text_buffer_get_iter_at_line_offset

    protected static final void gtk_text_buffer_get_iter_at_line_offset(Handle buffer,
                                                                        Handle iter,
                                                                        int lineNumber,
                                                                        int charOffset)

### gtk_text_buffer_get_iter_at_line_index

    protected static final void gtk_text_buffer_get_iter_at_line_index(Handle buffer,
                                                                       Handle iter,
                                                                       int lineNumber,
                                                                       int byteIndex)

### gtk_text_buffer_get_iter_at_offset

    protected static final void gtk_text_buffer_get_iter_at_offset(Handle buffer,
                                                                   Handle iter,
                                                                   int charOffset)

### gtk_text_buffer_get_iter_at_line

    protected static final void gtk_text_buffer_get_iter_at_line(Handle buffer,
                                                                 Handle iter,
                                                                 int lineNumber)

### gtk_text_buffer_get_start_iter

    protected static final void gtk_text_buffer_get_start_iter(Handle buffer,
                                                               Handle iter)

### gtk_text_buffer_get_end_iter

    protected static final void gtk_text_buffer_get_end_iter(Handle buffer,
                                                             Handle iter)

### gtk_text_buffer_get_bounds

    protected static final void gtk_text_buffer_get_bounds(Handle buffer,
                                                           int start,
                                                           int end)

### gtk_text_buffer_get_iter_at_mark

    protected static final void gtk_text_buffer_get_iter_at_mark(Handle buffer,
                                                                 Handle iter,
                                                                 int mark)

### gtk_text_buffer_get_iter_at_child_anchor

    protected static final void gtk_text_buffer_get_iter_at_child_anchor(Handle buffer,
                                                                         Handle iter,
                                                                         int anchor)

### gtk_text_buffer_get_modified

    protected static final boolean gtk_text_buffer_get_modified(Handle buffer)

### gtk_text_buffer_set_modified

    protected static final void gtk_text_buffer_set_modified(Handle buffer,
                                                             boolean setting)

### gtk_text_buffer_add_selection_clipboard

    protected static final void gtk_text_buffer_add_selection_clipboard(Handle buffer,
                                                                        Handle clipboard)

### gtk_text_buffer_remove_selection_clipboard

    protected static final void gtk_text_buffer_remove_selection_clipboard(Handle buffer,
                                                                           Handle clipboard)

### gtk_text_buffer_cut_clipboard

    protected static final void gtk_text_buffer_cut_clipboard(Handle buffer,
                                                              Handle clipboard,
                                                              boolean defaultEditable)

### gtk_text_buffer_copy_clipboard

    protected static final void gtk_text_buffer_copy_clipboard(Handle buffer,
                                                               Handle clipboard)

### gtk_text_buffer_paste_clipboard

    protected static final void gtk_text_buffer_paste_clipboard(Handle buffer,
                                                                Handle clipboard,
                                                                Handle overrideLocation,
                                                                boolean defaultEditable)

### gtk_text_buffer_get_selection_bounds

    protected static final boolean gtk_text_buffer_get_selection_bounds(Handle buffer,
                                                                        int start,
                                                                        int end)

### gtk_text_buffer_delete_selection

    protected static final boolean gtk_text_buffer_delete_selection(Handle buffer,
                                                                    boolean interactive,
                                                                    boolean defaultEditable)

### gtk_text_buffer_begin_user_action

    protected static final void gtk_text_buffer_begin_user_action(Handle buffer)

### gtk_text_buffer_end_user_action

    protected static final void gtk_text_buffer_end_user_action(Handle buffer)

### gtk_text_buffer_new_noTable

    protected static final Handle gtk_text_buffer_new_noTable()

### create_tag

    protected static final Handle create_tag(Handle buffer,
                                             java.lang.String name)

### insert_with_tag

    protected static final void insert_with_tag(Handle buffer,
                                                Handle iter,
                                                java.lang.String text,
                                                java.lang.String tag)

### gtk_text_buffer_select_range

    protected static final void gtk_text_buffer_select_range(Handle handle,
                                                             Handle ins,
                                                             Handle bound)

### gtk_text_buffer_get_selection_exists

    protected static final boolean gtk_text_buffer_get_selection_exists(Handle handle)

### gtk_text_buffer_get_selection_start

    protected static final Handle gtk_text_buffer_get_selection_start(Handle handle)

### gtk_text_buffer_get_selection_end

    protected static final Handle gtk_text_buffer_get_selection_end(Handle handle)

### gtk_text_buffer_get_iter_at_line_offsetMOD

    protected static final Handle gtk_text_buffer_get_iter_at_line_offsetMOD(Handle buffer,
                                                                             int lineNumber,
                                                                             int charOffset)

### gtk_text_buffer_get_iter_at_offsetMOD

    protected static final Handle gtk_text_buffer_get_iter_at_offsetMOD(Handle buffer,
                                                                        int charOffset)

### gtk_text_buffer_get_iter_at_lineMOD

    protected static final Handle gtk_text_buffer_get_iter_at_lineMOD(Handle buffer,
                                                                      int line)

### gtk_text_buffer_get_iter_at_markMOD

    protected static final Handle gtk_text_buffer_get_iter_at_markMOD(Handle buffer,
                                                                      Handle mark)

### gtk_text_buffer_get_iter_at_child_anchorMOD

    protected static final Handle gtk_text_buffer_get_iter_at_child_anchorMOD(Handle buffer,
                                                                              Handle anchor)

### gtk_text_buffer_get_start_iterMOD

    protected static final Handle gtk_text_buffer_get_start_iterMOD(Handle buffer)

### gtk_text_buffer_get_end_iterMOD

    protected static final Handle gtk_text_buffer_get_end_iterMOD(Handle buffer)

### gtk_text_buffer_paste_clipboardInsertPosition

    protected static final void gtk_text_buffer_paste_clipboardInsertPosition(Handle handle,
                                                                              Handle clip,
                                                                              boolean editable)